
-- Program configuration.

Cfg = {
	version = "0.1.0",

	-- Display.
	fullscreen	= false,
	screenWidth	= 800,
	screenHeight	= 480,
	screenBPP	= 0,		-- 0 = current bits per pixel.
	
	-- Sound.
	channels	= 8,		-- Number of mixing channels.
	frequency	= 22050,	-- Use 44100 for 44.1KHz (CD audio).
	chunksize	= 512,		-- Less is slower but more accurate.
	stereo		= true,		-- Mono or stereo output.

	-- Editor.
	loadEditor		= true,
	defaultShapeColor	= {r=0.0, g=0.8, b=0.4},
	selectedShapeColor	= {r=0.9, g=0,   b=0.5},
	invalidShapeColor	= {r=0.8, g=0.4, b=0.1},

	-- Debug things.
	printExtensions = false,	-- Print the OpenGL extension string.
	FPSUpdateInterval = 500,	-- FPS update interval in milliseconds.
	gameSpeed = 0			-- Negative values slow the game down,
					-- positive values speed it up.
}

-- Make sure the configuration is sane.
assert(Cfg.screenWidth >= 320 and Cfg.screenHeight >= 240)

assert(Cfg.channels > 0 and Cfg.channels <= 16)
assert(Cfg.frequency == 22050 or Cfg.frequency == 44100)
assert(Cfg.stereo == true or Cfg.stereo == false)
assert(Cfg.chunksize >= 256 and Cfg.chunksize <= 8192)

assert(Cfg.FPSUpdateInterval > 0);
assert(Cfg.gameSpeed >= -10 and Cfg.gameSpeed <= 10)

return Cfg
